import { VersionLabel } from './release';
declare enum SEMVER {
    major = "major",
    premajor = "premajor",
    minor = "minor",
    preminor = "preminor",
    patch = "patch",
    prepatch = "prepatch",
    noVersion = ""
}
export declare type IVersionLabels = Map<VersionLabel, string>;
export default SEMVER;
export declare function getHigherSemverTag(left: SEMVER, right: string): SEMVER;
interface ISemVerOptions {
    onlyPublishWithReleaseLabel?: boolean;
    skipReleaseLabels?: string[];
}
export declare function calculateSemVerBump(labels: string[][], labelMap: IVersionLabels, { onlyPublishWithReleaseLabel, skipReleaseLabels }?: ISemVerOptions): SEMVER.major | SEMVER.premajor | SEMVER.premajor | SEMVER | SEMVER.noVersion;
